Index: /branches/multichoice/gui/scripts/vtkglyphviewer.tcl
===================================================================
--- /branches/multichoice/gui/scripts/vtkglyphviewer.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/vtkglyphviewer.tcl	(revision 6371)
@@ -102,5 +102,5 @@
     private method ReceiveDataset { args }
     private method ReceiveImage { args }
-    private method ReceiveLegend { colormap title vmin vmax size }
+    private method ReceiveLegend { colormap title min max size }
     private method RequestLegend {}
     private method Rotate {option x y}
@@ -151,10 +151,9 @@
     private variable _rotatePending 0
     private variable _cutplanePending 0
-    private variable _field      ""
-    private variable _colorMode "vmag"; # Mode of colormap (vmag or scalar)
     private variable _fields
     private variable _curFldName ""
     private variable _curFldLabel ""
     private variable _curFldComp 3
+    private variable _colorMode "vmag"; # Mode of colormap (vmag or scalar)
     private variable _mouseOver "";     # what called LegendRangeAction:
                                         # vmin or vmax
@@ -591,7 +590,4 @@
     }
     array set params $settings
-    set params(-description) ""
-    set params(-param) ""
-    array set params $settings
 
     if {$params(-color) == "auto" || $params(-color) == "autoreset"} {
@@ -630,5 +626,4 @@
         set _dlist [lreplace $_dlist $pos $pos]
         array unset _obj2ovride $dataobj-*
-        array unset _settings $dataobj-*
         set changed 1
     }
@@ -691,5 +686,5 @@
             return $dlist
         }
-        -image {
+        "-image" {
             if {[llength $args] != 2} {
                 error "wrong # args: should be \"get -image view\""
@@ -705,5 +700,5 @@
         }
         default {
-            error "bad option \"$op\": should be -objects or -image"
+            error "bad option \"$op\": should be -objects, -visible or -image"
         }
     }
@@ -1323,8 +1318,4 @@
 itcl::body Rappture::VtkGlyphViewer::InitSettings { args } {
     foreach spec $args {
-        if { [info exists _settings($_first${spec})] } {
-            # Reset global setting with dataobj specific setting
-            set _settings($spec) $_settings($_first${spec})
-        }
         AdjustSetting $spec
     }
@@ -2212,5 +2203,5 @@
                     SendCmd "camera zoom $_view($what)"
                 }
-             }
+            }
         }
     }
@@ -2246,10 +2237,10 @@
     radiobutton $inner.vtk_button -text "VTK data file" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Arial 9 " \
+        -font "Arial 9" \
         -value vtk
     Rappture::Tooltip::for $inner.vtk_button "Save as VTK data file."
     radiobutton $inner.image_button -text "Image File" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Arial 9 " \
+        -font "Arial 9" \
         -value image
     Rappture::Tooltip::for $inner.image_button \
Index: /branches/multichoice/gui/scripts/vtkheightmapviewer.tcl
===================================================================
--- /branches/multichoice/gui/scripts/vtkheightmapviewer.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/vtkheightmapviewer.tcl	(revision 6371)
@@ -71,5 +71,4 @@
     private method BuildDownloadPopup { widget command }
     private method CameraReset {}
-    private method Combo { option }
     private method Connect {}
     private method CurrentDatasets {args}
@@ -88,4 +87,5 @@
     private method IsValidObject { dataobj }
     private method LeaveLegend {}
+    private method LegendTitleAction { option }
     private method MotionLegend { x y }
     private method Pan {option x y}
@@ -103,4 +103,5 @@
     private method Rotate {option x y}
     private method SetCurrentColormap { color }
+    private method SetCurrentFieldName { dataobj }
     private method SetLegendTip { x y }
     private method SetObjectStyle { dataobj comp }
@@ -214,8 +215,8 @@
 
     array set _settings {
-        -axisflymode            "static"
+        -axesvisible            1
         -axislabels             1
         -axisminorticks         1
-        -axisvisible            1
+        -axismode               "static"
         -colormap               BCGYR
         -colormapdiscrete       0
@@ -243,6 +244,12 @@
     array set _changed {
         -colormap               0
+        -colormapdiscrete       0
+        -colormapvisible        0
+        -edges                  0
+        -isolinecolor           0
+        -isolinesvisible        0
         -numisolines            0
         -opacity                0
+        -wireframe              0
     }
     itk_component add view {
@@ -255,7 +262,5 @@
 
     itk_component add fieldmenu {
-        menu $itk_component(plotarea).menu \
-            -relief flat \
-            -tearoff 0
+        menu $itk_component(plotarea).menu -relief flat -tearoff 0
     } {
         usual
@@ -286,5 +291,6 @@
     }
     pack $itk_component(reset) -side top -padx 2 -pady { 2 0 }
-    Rappture::Tooltip::for $itk_component(reset) "Reset the view to the default zoom level"
+    Rappture::Tooltip::for $itk_component(reset) \
+        "Reset the view to the default zoom level"
 
     itk_component add zoomin {
@@ -483,7 +489,4 @@
     }
     array set params $settings
-    set params(-description) ""
-    set params(-param) ""
-    array set params $settings
 
     if {$params(-color) == "auto" || $params(-color) == "autoreset"} {
@@ -523,5 +526,4 @@
         set _dlist [lreplace $_dlist $pos $pos]
         array unset _obj2ovride $dataobj-*
-        array unset _settings $dataobj-*
         set changed 1
     }
@@ -583,5 +585,5 @@
             return $dlist
         }
-        -image {
+        "-image" {
             if {[llength $args] != 2} {
                 error "wrong # args: should be \"get -image view\""
@@ -597,5 +599,5 @@
         }
         default {
-            error "bad option \"$op\": should be -objects or -image"
+            error "bad option \"$op\": should be -objects, -visible or -image"
         }
     }
@@ -920,5 +922,7 @@
         # Reset the camera and other view parameters
         #
-        InitSettings -isheightmap -background
+        InitSettings -isheightmap -background \
+            -xgrid -ygrid -zgrid -axismode \
+            -axesvisible -axislabels -axisminorticks
 
         # Setting a custom exponent and label format for axes is causing
@@ -933,4 +937,5 @@
         #SendCmd "axis exp 0 0 0 1"
 
+        SendCmd "axis tickpos outside"
         SendCmd "axis lrot z 90"
         $_arcball quaternion [ViewToQuaternion]
@@ -951,5 +956,5 @@
 
     set _first ""
-    # Start off with no datasets are visible.
+    # Start off with no datasets visible.
     SendCmd "dataset visible 0"
     set scale [GetHeightmapScale]
@@ -957,4 +962,5 @@
         if { [info exists _obj2ovride($dataobj-raise)] &&  $_first == "" } {
             set _first $dataobj
+            SetCurrentFieldName $dataobj
         }
         foreach comp [$dataobj components] {
@@ -998,39 +1004,7 @@
         }
     }
-    if { $_first != "" } {
-        $itk_component(field) choices delete 0 end
-        $itk_component(fieldmenu) delete 0 end
-        array unset _fields
-        set _curFldName ""
-        foreach cname [$_first components] {
-            foreach fname [$_first fieldnames $cname] {
-                if { [info exists _fields($fname)] } {
-                    continue
-                }
-                foreach { label units components } \
-                    [$_first fieldinfo $fname] break
-                $itk_component(field) choices insert end "$fname" "$label"
-                $itk_component(fieldmenu) add radiobutton -label "$label" \
-                    -value $label -variable [itcl::scope _curFldLabel] \
-                    -selectcolor red \
-                    -activebackground $itk_option(-plotbackground) \
-                    -activeforeground $itk_option(-plotforeground) \
-                    -font "Arial 8" \
-                    -command [itcl::code $this Combo invoke]
-                set _fields($fname) [list $label $units $components]
-                if { $_curFldName == "" } {
-                    set _curFldName $fname
-                    set _curFldLabel $label
-                }
-            }
-        }
-        $itk_component(field) value $_curFldLabel
-    }
+
     InitSettings -stretchtofit -outline
-
     if { $_reset } {
-        SendCmd "axis tickpos outside"
-        #SendCmd "axis lformat all %g"
-
         foreach axis { x y z } {
             set label ""
@@ -1089,7 +1063,5 @@
         }
         PanCamera
-        InitSettings -xgrid -ygrid -zgrid \
-            -axisvisible -axislabels -heightmapscale -field -isheightmap \
-            -numisolines
+        InitSettings -heightmapscale -field -isheightmap -numisolines
         if { [array size _fields] < 2 } {
             catch {blt::table forget $itk_component(field) $itk_component(field_l)}
@@ -1331,8 +1303,4 @@
 itcl::body Rappture::VtkHeightmapViewer::InitSettings { args } {
     foreach spec $args {
-        if { [info exists _settings($_first${spec})] } {
-            # Reset global setting with dataobj specific setting
-            set _settings($spec) $_settings($_first${spec})
-        }
         AdjustSetting $spec
     }
@@ -1351,9 +1319,7 @@
     }
     switch -- $what {
-        "-axisflymode" {
-            set mode [$itk_component(axisflymode) value]
-            set mode [$itk_component(axisflymode) translate $mode]
-            set _settings($what) $mode
-            SendCmd "axis flymode $mode"
+        "-axesvisible" {
+            set bool $_settings($what)
+            SendCmd "axis visible all $bool"
         }
         "-axislabels" {
@@ -1365,7 +1331,9 @@
             SendCmd "axis minticks all $bool"
         }
-        "-axisvisible" {
-            set bool $_settings($what)
-            SendCmd "axis visible all $bool"
+        "-axismode" {
+            set mode [$itk_component(axismode) value]
+            set mode [$itk_component(axismode) translate $mode]
+            set _settings($what) $mode
+            SendCmd "axis flymode $mode"
         }
         "-background" {
@@ -1391,4 +1359,5 @@
             if { $color == "none" } {
                 if { $_settings(-colormapvisible) } {
+                    set _changed(-colormapvisible) 1
                     SendCmd "heightmap surface 0"
                     set _settings(-colormapvisible) 0
@@ -1396,4 +1365,5 @@
             } else {
                 if { !$_settings(-colormapvisible) } {
+                    set _changed(-colormapvisible) 1
                     SendCmd "heightmap surface 1"
                     set _settings(-colormapvisible) 1
@@ -1408,9 +1378,6 @@
             EventuallyRequestLegend
         }
-        "-colormapvisible" {
-            set bool $_settings($what)
-            SendCmd "heightmap surface $bool"
-        }
         "-colormapdiscrete" {
+            set _changed($what) 1
             set bool $_settings($what)
             set numColors [expr $_settings(-numisolines) + 1]
@@ -1428,5 +1395,11 @@
             EventuallyRequestLegend
         }
+        "-colormapvisible" {
+            set _changed($what) 1
+            set bool $_settings($what)
+            SendCmd "heightmap surface $bool"
+        }
         "-edges" {
+            set _changed($what) 1
             set bool $_settings($what)
             SendCmd "heightmap edges $bool"
@@ -1574,12 +1547,16 @@
         }
         "-isolinecolor" {
+            set _changed($what) 1
             set color [$itk_component(isolinecolor) value]
             if { $color == "none" } {
                 if { $_settings(-isolinesvisible) } {
+                    set _changed(-isolinesvisible) 1
                     SendCmd "heightmap isolines 0"
                     set _settings(-isolinesvisible) 0
                 }
             } else {
+                set _settings($what) $color
                 if { !$_settings(-isolinesvisible) } {
+                    set _changed(-isolinesvisible) 1
                     SendCmd "heightmap isolines 1"
                     set _settings(-isolinesvisible) 1
@@ -1590,5 +1567,10 @@
         }
         "-isolinesvisible" {
+            set _changed($what) 1
             set bool $_settings($what)
+            set color [$itk_component(isolinecolor) value]
+            if { $bool && $color != $_settings(-isolinecolor)} {
+                $itk_component(isolinecolor) value $_settings(-isolinecolor)
+            }
             SendCmd "heightmap isolines $bool"
             DrawLegend
@@ -1634,4 +1616,5 @@
         }
         "-outline" {
+            set _changed($what) 1
             if { $_settings(-isheightmap) } {
                 SendCmd "outline visible 0"
@@ -1657,4 +1640,5 @@
         }
         "-wireframe" {
+            set _changed($what) 1
             set bool $_settings($what)
             SendCmd "heightmap wireframe $bool"
@@ -1717,6 +1701,6 @@
         set cmap $_currentColormap
         if { ![info exists _colormaps($cmap)] } {
-           BuildColormap $cmap
-           set _colormaps($cmap) 1
+            BuildColormap $cmap
+            set _colormaps($cmap) 1
         }
         #SendCmd "legend $cmap scalar $_curFldName {} $w $h 0"
@@ -2034,6 +2018,6 @@
     checkbutton $inner.visible \
         -text "Axes" \
-        -variable [itcl::scope _settings(-axisvisible)] \
-        -command [itcl::code $this AdjustSetting -axisvisible] \
+        -variable [itcl::scope _settings(-axesvisible)] \
+        -command [itcl::code $this AdjustSetting -axesvisible] \
         -font "Arial 9"
     checkbutton $inner.labels \
@@ -2066,5 +2050,5 @@
     label $inner.mode_l -text "Mode" -font "Arial 9"
 
-    itk_component add axisflymode {
+    itk_component add axismode {
         Rappture::Combobox $inner.mode -width 10 -editable 0
     }
@@ -2074,6 +2058,6 @@
         "furthest_triad"  "farthest" \
         "outer_edges"     "outer"
-    $itk_component(axisflymode) value $_settings(-axisflymode)
-    bind $inner.mode <<Value>> [itcl::code $this AdjustSetting -axisflymode]
+    $itk_component(axismode) value $_settings(-axismode)
+    bind $inner.mode <<Value>> [itcl::code $this AdjustSetting -axismode]
 
     blt::table $inner \
@@ -2212,10 +2196,10 @@
     radiobutton $inner.vtk_button -text "VTK data file" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Arial 9 " \
+        -font "Arial 9" \
         -value vtk
     Rappture::Tooltip::for $inner.vtk_button "Save as VTK data file."
     radiobutton $inner.image_button -text "Image File" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Arial 9 " \
+        -font "Arial 9" \
         -value image
     Rappture::Tooltip::for $inner.image_button \
@@ -2258,7 +2242,17 @@
     set tag $dataobj-$comp
     array set style {
-        -color BCGYR
-        -levels 10
-        -opacity 1.0
+        -color            BCGYR
+        -colormapdiscrete 0
+        -colormapvisible  1
+        -edgecolor        black
+        -edges            0
+        -isolinecolor     black
+        -isolinesvisible  1
+        -isolinewidth     1.0
+        -levels           10
+        -linewidth        1.0
+        -opacity          1.0
+        -outline          0
+        -wireframe        0
     }
     set stylelist [$dataobj style $comp]
@@ -2298,18 +2292,38 @@
         DrawLegend
     }
+    foreach setting {-edges -outline -wireframe -colormapdiscrete \
+                     -colormapvisible -isolinecolor -isolinesvisible} {
+        if {$_changed($setting)} {
+            # User-modified UI setting overrides style
+            set style($setting) $_settings($setting)
+        } else {
+            # Set UI control to style setting (tool provided or default)
+            set _settings($setting) $style($setting)
+        }
+    }
+
     SendCmd "outline add $tag"
     SendCmd "outline color [Color2RGB $itk_option(-plotforeground)] $tag"
-    SendCmd "outline visible $_settings(-outline) $tag"
+    SendCmd "outline visible $style(-outline) $tag"
+
     set scale [GetHeightmapScale]
     SendCmd "[list heightmap add contourlist $_contourList $scale $tag]"
     set _comp2scale($tag) $_settings(-heightmapscale)
-    SendCmd "heightmap edges $_settings(-edges) $tag"
-    SendCmd "heightmap wireframe $_settings(-wireframe) $tag"
+    SendCmd "heightmap edges $style(-edges) $tag"
+    SendCmd "heightmap linecolor [Color2RGB $style(-edgecolor)] $tag"
+    SendCmd "heightmap linewidth $style(-linewidth) $tag"
+    SendCmd "heightmap wireframe $style(-wireframe) $tag"
     SetCurrentColormap $style(-color)
-    set color [$itk_component(isolinecolor) value]
-    SendCmd "heightmap isolinecolor [Color2RGB $color] $tag"
+    if {$style(-colormapdiscrete)} {
+        SendCmd "heightmap preinterp 1 $tag"
+        set numColors [expr $style(-levels) + 1]
+        SendCmd "colormap res $numColors $style(-color)"
+    }
+    SendCmd "heightmap isolinecolor [Color2RGB $style(-isolinecolor)] $tag"
+    $itk_component(isolinecolor) value $style(-isolinecolor)
+    SendCmd "heightmap isolinewidth $style(-isolinewidth) $tag"
     SendCmd "heightmap lighting $_settings(-isheightmap) $tag"
-    SendCmd "heightmap isolines $_settings(-isolinesvisible) $tag"
-    SendCmd "heightmap surface $_settings(-colormapvisible) $tag"
+    SendCmd "heightmap isolines $style(-isolinesvisible) $tag"
+    SendCmd "heightmap surface $style(-colormapvisible) $tag"
     SendCmd "heightmap opacity $style(-opacity) $tag"
     set _settings(-opacity) [expr $style(-opacity) * 100.0]
@@ -2349,5 +2363,5 @@
 # DrawLegend --
 #
-# Draws the legend in the own canvas on the right side of the plot area.
+# Draws the legend in its own canvas on the right side of the plot area.
 #
 itcl::body Rappture::VtkHeightmapViewer::DrawLegend {} {
@@ -2437,7 +2451,7 @@
     }
 
-    $c bind title <ButtonPress> [itcl::code $this Combo post]
-    $c bind title <Enter> [itcl::code $this Combo activate]
-    $c bind title <Leave> [itcl::code $this Combo deactivate]
+    $c bind title <ButtonPress> [itcl::code $this LegendTitleAction post]
+    $c bind title <Enter> [itcl::code $this LegendTitleAction enter]
+    $c bind title <Leave> [itcl::code $this LegendTitleAction leave]
     # Reset the item coordinates according the current size of the plot.
     if { [info exists _limits($_curFldName)] } {
@@ -2553,15 +2567,17 @@
 
 # ----------------------------------------------------------------------
-# USAGE: _dropdown post
-# USAGE: _dropdown unpost
-# USAGE: _dropdown select
-#
-# Used internally to handle the dropdown list for this combobox.  The
-# post/unpost options are invoked when the list is posted or unposted
-# to manage the relief of the controlling button.  The select option
-# is invoked whenever there is a selection from the list, to assign
-# the value back to the gauge.
-# ----------------------------------------------------------------------
-itcl::body Rappture::VtkHeightmapViewer::Combo {option} {
+# USAGE: LegendTitleAction post
+# USAGE: LegendTitleAction enter
+# USAGE: LegendTitleAction leave
+# USAGE: LegendTitleAction save
+#
+# Used internally to handle the dropdown list for the fields menu combobox.
+# The post option is invoked when the field title is pressed to launch the
+# dropdown.  The enter option is invoked when the user mouses over the field
+# title. The leave option is invoked when the user moves the mouse away
+# from the field title.  The save option is invoked whenever there is a
+# selection from the list, to alert the visualization server.
+# ----------------------------------------------------------------------
+itcl::body Rappture::VtkHeightmapViewer::LegendTitleAction {option} {
     set c $itk_component(view)
     switch -- $option {
@@ -2573,16 +2589,16 @@
             tk_popup $itk_component(fieldmenu) $x $y
         }
-        activate {
+        enter {
             $c itemconfigure title -fill red
         }
-        deactivate {
+        leave {
             $c itemconfigure title -fill $itk_option(-plotforeground)
         }
-        invoke {
+        save {
             $itk_component(field) value $_curFldLabel
             AdjustSetting -field
         }
         default {
-            error "bad option \"$option\": should be post, unpost, select"
+            error "bad option \"$option\": should be post, enter, leave or save"
         }
     }
@@ -2634,2 +2650,33 @@
     blt::vector destroy $v
 }
+
+itcl::body Rappture::VtkHeightmapViewer::SetCurrentFieldName { dataobj } {
+    set _first $dataobj
+    $itk_component(field) choices delete 0 end
+    $itk_component(fieldmenu) delete 0 end
+    array unset _fields
+    set _curFldName ""
+    foreach cname [$_first components] {
+        foreach fname [$_first fieldnames $cname] {
+            if { [info exists _fields($fname)] } {
+                continue
+            }
+            foreach { label units components } \
+                [$_first fieldinfo $fname] break
+            $itk_component(field) choices insert end "$fname" "$label"
+            $itk_component(fieldmenu) add radiobutton -label "$label" \
+                -value $label -variable [itcl::scope _curFldLabel] \
+                -selectcolor red \
+                -activebackground $itk_option(-plotbackground) \
+                -activeforeground $itk_option(-plotforeground) \
+                -font "Arial 8" \
+                -command [itcl::code $this LegendTitleAction save]
+            set _fields($fname) [list $label $units $components]
+            if { $_curFldName == "" } {
+                set _curFldName $fname
+                set _curFldLabel $label
+            }
+        }
+    }
+    $itk_component(field) value $_curFldLabel
+}
